Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/vocabularies.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/vocabularies.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/vocabularies.py	(revision 9169)
@@ -36,8 +36,9 @@
 nats_vocab = SimpleKofaVocabulary(*COUNTRIES)
 
-def study_levels(studycourse):
-    if studycourse.certificate is not None:
-        start_level = int(studycourse.certificate.start_level)
-        end_level = int(studycourse.certificate.end_level)
+def study_levels(context):
+    certificate = getattr(context, 'certificate', None)
+    if  certificate is not None:
+        start_level = int(certificate.start_level)
+        end_level = int(certificate.end_level)
         if start_level == 999 or end_level == 999:
             levels = [999]
@@ -50,5 +51,7 @@
     else:
         # default level range
-        levels = [level for level in range(100,1000,10) if level % 100 < 30]
+        levels = [10, ]
+        levels += [level for level in range(100,1000,10) if level % 100 < 30]
+        levels.append(999)
     return levels
 
@@ -68,10 +71,11 @@
 
     def getTitle(self, context, value):
-        if context.certificate is not None:
-            start_level = int(context.certificate.start_level)
-            end_level = int(context.certificate.end_level)
+        certificate = getattr(context, 'certificate', None)
+        if certificate is not None:
+            start_level = int(certificate.start_level)
+            end_level = int(certificate.end_level)
         else:
             # default level range
-            start_level = 100
+            start_level = 10
             end_level = 1000
         if start_level == 999 or end_level == 999:
@@ -79,4 +83,5 @@
                 return _('Error: wrong level id ${value}',
                     mapping={'value': value})
+        if value == 999:
             return course_levels.by_value[999].title
         if value < start_level or value > end_level + 120:
Index: main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/workflow.py
===================================================================
--- main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/workflow.py	(revision 9168)
+++ main/waeup.kofa/branches/uli-async-update/src/waeup/kofa/students/workflow.py	(revision 9169)
@@ -2,4 +2,5 @@
 """
 import grok
+from datetime import datetime
 from zope.component import getUtility
 from hurry.workflow.workflow import Transition, WorkflowState, NullCondition
@@ -12,8 +13,11 @@
 from waeup.kofa.workflow import KofaWorkflow, KofaWorkflowInfo
 from waeup.kofa.students.interfaces import IStudent, IStudentsUtils
+from waeup.kofa.utils.helpers import get_current_principal
 
 
 IMPORTABLE_STATES = (ADMITTED, CLEARANCE, REQUESTED, CLEARED, PAID, RETURNING,
     REGISTERED, VALIDATED)
+
+FORBIDDEN_POSTGRAD_STATES = (RETURNING, REGISTERED, VALIDATED)
 
 REGISTRATION_TRANSITIONS = (
@@ -23,5 +27,5 @@
         source = None,
         condition = NullCondition,
-        msg = _('Student record created'),
+        msg = _('Record created'),
         destination = CREATED),
 
@@ -29,5 +33,5 @@
         transition_id = 'admit',
         title = _('Admit student'),
-        msg = _('Student admitted'),
+        msg = _('Admitted'),
         source = CREATED,
         destination = ADMITTED),
@@ -63,6 +67,6 @@
     Transition(
         transition_id = 'reset3',
-        title = _('Reset to clearance'),
-        msg = _("Reset to 'clearance'"),
+        title = _('Reset to clearance started'),
+        msg = _("Reset to 'clearance started'"),
         source = REQUESTED,
         destination = CLEARANCE),
@@ -77,6 +81,6 @@
     Transition(
         transition_id = 'reset4',
-        title = _('Reset to clearance'),
-        msg = _("Reset to 'clearance'"),
+        title = _('Reset to clearance started'),
+        msg = _("Reset to 'clearance started'"),
         source = CLEARED,
         destination = CLEARANCE),
@@ -85,5 +89,5 @@
         transition_id = 'pay_first_school_fee',
         title = _('Pay school fee'),
-        msg = _('School fee paid'),
+        msg = _('First school fee payment made'),
         source = CLEARED,
         destination = PAID),
@@ -92,5 +96,5 @@
         transition_id = 'approve_first_school_fee',
         title = _('Approve payment'),
-        msg = _('School fee payment approved'),
+        msg = _('First school fee payment approved'),
         source = CLEARED,
         destination = PAID),
@@ -106,5 +110,5 @@
         transition_id = 'pay_school_fee',
         title = _('Pay school fee'),
-        msg = _('Payment made'),
+        msg = _('School fee payment made'),
         source = RETURNING,
         destination = PAID),
@@ -112,6 +116,6 @@
     Transition(
         transition_id = 'pay_pg_fee',
-        title = _('Pay postgraduate school fee'),
-        msg = _('Payment made'),
+        title = _('Pay PG school fee'),
+        msg = _('PG school fee payment made'),
         source = PAID,
         destination = PAID),
@@ -119,5 +123,5 @@
     Transition(
         transition_id = 'approve_school_fee',
-        title = _('Approve payment'),
+        title = _('Approve school fee payment'),
         msg = _('School fee payment approved'),
         source = RETURNING,
@@ -126,6 +130,6 @@
     Transition(
         transition_id = 'approve_pg_fee',
-        title = _('Approve postgraduate payment'),
-        msg = _('School fee payment approved'),
+        title = _('Approve PG school fee payment'),
+        msg = _('PG school fee payment approved'),
         source = PAID,
         destination = PAID),
@@ -147,6 +151,6 @@
     Transition(
         transition_id = 'reset7',
-        title = _('Reset to paid'),
-        msg = _("Reset to 'paid'"),
+        title = _('Reset to school fee paid'),
+        msg = _("Reset to 'school fee paid'"),
         source = REGISTERED,
         destination = PAID),
@@ -161,6 +165,6 @@
     Transition(
         transition_id = 'reset8',
-        title = _('Reset to paid'),
-        msg = _("Reset to 'paid'"),
+        title = _('Reset to school fee paid'),
+        msg = _("Reset to 'school fee paid'"),
         source = VALIDATED,
         destination = PAID),
@@ -175,6 +179,6 @@
     Transition(
         transition_id = 'reset9',
-        title = _('Reset to validated'),
-        msg = _("Reset to 'validated'"),
+        title = _('Reset to courses validated'),
+        msg = _("Reset to 'courses validated'"),
         source = RETURNING,
         destination = VALIDATED),
@@ -183,4 +187,5 @@
 IMPORTABLE_TRANSITIONS = [i.transition_id for i in REGISTRATION_TRANSITIONS]
 
+FORBIDDEN_POSTGRAD_TRANS = ['reset6', 'register_courses']
 LOCK_CLEARANCE_TRANS = ('reset2', 'request_clearance')
 UNLOCK_CLEARANCE_TRANS = ('reset3', 'reset4', 'start_clearance')
@@ -212,5 +217,5 @@
 
     Lock and unlock clearance form.
-    Triger actions after school fee payment.
+    Trigger actions after school fee payment.
     """
 
@@ -231,4 +236,23 @@
         new_session = obj['studycourse'].current_session + 1
         obj['studycourse'].current_session = new_session
+    elif event.transition.transition_id == 'validate_courses':
+        current_level = obj['studycourse'].current_level
+        level_object = obj['studycourse'].get(str(current_level), None)
+        if level_object is not None:
+            user = get_current_principal()
+            if user is None:
+                usertitle = 'system'
+            else:
+                usertitle = getattr(user, 'public_name', None)
+                if not usertitle:
+                    usertitle = user.title
+            level_object.validated_by = usertitle
+            level_object.validation_date = datetime.utcnow()
+    elif event.transition.transition_id == 'reset8':
+        current_level = obj['studycourse'].current_level
+        level_object = obj['studycourse'].get(str(current_level), None)
+        if level_object is not None:
+            level_object.validated_by = None
+            level_object.validation_date = None
     # In some tests we don't have a students container
     try:
